library(mlogit)


for(m in 1:2){

g1<-c("../Inc/agem3.csv", "../Inc/agef3.csv")
g2<-c("../Output/agem3_plot.txt", "../Output/agef3_plot.txt")
g3<-c("../LogInc/agem3.csv", "../LogInc/agef3.csv")
g4<-c("../LogOutput/agem3_plot.txt", "../LogOutput/agef3_plot.txt")
g5<-c("../ComOutput/agem3_plot.txt", "../ComOutput/agef3_plot.txt")

fact<-read.table("../factors.txt", head=TRUE)
fact1<-as.matrix(fact)

plot1<-matrix(nrow=121,ncol=3)
plot2<-matrix(nrow=121,ncol=3)
plot3<-matrix(nrow=121,ncol=3)
plot4<-matrix(nrow=121,ncol=3)

plotm1<-matrix(nrow=121,ncol=3)
plotm2<-matrix(nrow=121,ncol=3)
plotm3<-matrix(nrow=121,ncol=3)
plotm4<-matrix(nrow=121,ncol=3)

newplot1<-matrix(nrow=121,ncol=3)
newplot2<-matrix(nrow=121,ncol=3)
newplot3<-matrix(nrow=121,ncol=3)
newplot4<-matrix(nrow=121,ncol=3)

res1a<-matrix(nrow=121,ncol=1000)
res1b<-matrix(nrow=121,ncol=1000)
res1c<-matrix(nrow=121,ncol=1000)
res1d<-matrix(nrow=121,ncol=1000)

resm1a<-matrix(nrow=121,ncol=1000)
resm1b<-matrix(nrow=121,ncol=1000)
resm1c<-matrix(nrow=121,ncol=1000)
resm1d<-matrix(nrow=121,ncol=1000)

nres1<-matrix(nrow=121,ncol=1000)
nres2<-matrix(nrow=121,ncol=1000)
nres3<-matrix(nrow=121,ncol=1000)
nres4<-matrix(nrow=121,ncol=1000)

## Hurdle model on original data##

aub1 <- read.csv(file=paste(g1[m]),head=TRUE,sep=",")
aub2<-subset(aub1,p==1)

attach(aub1)
obs<-dim(aub1)[1]
wgt1<-iexps*obs/sum(iexps)
log1<-glm(p~U0+factor(month)+factor(defn)+factor(amt)+factor(ncb)+factor(cont)+factor(aids),family=binomial, weights=wgt1,data=aub1)

if(names(sort(-table(month)))[1]=="1"){x1<-c(0,0,0,0,0,0,0,0,0,0,0)}
if(names(sort(-table(month)))[1]=="2"){x1<-c(1,0,0,0,0,0,0,0,0,0,0)}
if(names(sort(-table(month)))[1]=="3"){x1<-c(0,1,0,0,0,0,0,0,0,0,0)}
if(names(sort(-table(month)))[1]=="4"){x1<-c(0,0,1,0,0,0,0,0,0,0,0)}
if(names(sort(-table(month)))[1]=="5"){x1<-c(0,0,0,1,0,0,0,0,0,0,0)}
if(names(sort(-table(month)))[1]=="6"){x1<-c(0,0,0,0,1,0,0,0,0,0,0)}
if(names(sort(-table(month)))[1]=="7"){x1<-c(0,0,0,0,0,1,0,0,0,0,0)}
if(names(sort(-table(month)))[1]=="8"){x1<-c(0,0,0,0,0,0,1,0,0,0,0)}
if(names(sort(-table(month)))[1]=="9"){x1<-c(0,0,0,0,0,0,0,1,0,0,0)}
if(names(sort(-table(month)))[1]=="10"){x1<-c(0,0,0,0,0,0,0,0,1,0,0)}
if(names(sort(-table(month)))[1]=="11"){x1<-c(0,0,0,0,0,0,0,0,0,1,0)}
if(names(sort(-table(month)))[1]=="12"){x1<-c(0,0,0,0,0,0,0,0,0,0,1)}
detach(aub1)

attach(aub2)
obs<-dim(aub2)[1]
wgt2<-iexps*obs/sum(iexps)
ae=iabp/iexpt
lmu1<- lm(log(ae)~U0+factor(month)+factor(defn)+factor(amt)+factor(ncb)+factor(cont)+factor(aids), weights=sqrt(wgt2),data=aub2)
s21 <- summary(lmu1)$sigma^2

if(names(sort(-table(month)))[1]=="1"){x2<-c(0,0,0,0,0,0,0,0,0,0,0)}
if(names(sort(-table(month)))[1]=="2"){x2<-c(1,0,0,0,0,0,0,0,0,0,0)}
if(names(sort(-table(month)))[1]=="3"){x2<-c(0,1,0,0,0,0,0,0,0,0,0)}
if(names(sort(-table(month)))[1]=="4"){x2<-c(0,0,1,0,0,0,0,0,0,0,0)}
if(names(sort(-table(month)))[1]=="5"){x2<-c(0,0,0,1,0,0,0,0,0,0,0)}
if(names(sort(-table(month)))[1]=="6"){x2<-c(0,0,0,0,1,0,0,0,0,0,0)}
if(names(sort(-table(month)))[1]=="7"){x2<-c(0,0,0,0,0,1,0,0,0,0,0)}
if(names(sort(-table(month)))[1]=="8"){x2<-c(0,0,0,0,0,0,1,0,0,0,0)}
if(names(sort(-table(month)))[1]=="9"){x2<-c(0,0,0,0,0,0,0,1,0,0,0)}
if(names(sort(-table(month)))[1]=="10"){x2<-c(0,0,0,0,0,0,0,0,1,0,0)}
if(names(sort(-table(month)))[1]=="11"){x2<-c(0,0,0,0,0,0,0,0,0,1,0)}
if(names(sort(-table(month)))[1]=="12"){x2<-c(0,0,0,0,0,0,0,0,0,0,1)}
detach(aub2)

z1<- matrix(nrow=121,ncol=3)

for( i in 31:151){
j=(i-1)/1000
res1<-matrix(nrow=120,ncol=2)

for(k in 1:120){
nxx<-c(1,j,x1,fact1[k,])
nyx<-c(1,j,x2,fact1[k,])
y1<-nxx%*%coef(log1)
y2<-nyx%*%coef(lmu1)
res1[k,1]<-exp(y1)/(1+exp(y1))
res1[k,2]<-exp(y2+s21/2)
}

oa=i-30
z1[oa,1]<-apply(res1,2,mean)[1]
z1[oa,2]<-apply(res1,2,mean)[2]
z1[oa,3]<-z1[oa,1]*z1[oa,2]
}

plot1[,1]<-z1[,1]
plot2[,1]<-z1[,2]
plot3[,1]<-z1[,3]

## Hurdle model Bootstrap##

fit1<-fitted(log1)
obs1<-dim(aub1)[1]
newlog<-replicate(1000,rbinom(obs1,1,fit1))

fit2<-fitted(lmu1)
obs2<-dim(aub2)[1]
newlm<-replicate(1000,rnorm(obs2,mean=fit2,sd=sqrt(s21)))

for( l in 1:1000){
newp<-newlog[,l]
attach(aub1)
log1<-glm(newp~U0+factor(month)+factor(defn)+factor(amt)+factor(ncb)+factor(cont)+factor(aids),family=binomial, weights=wgt1)
detach(aub1)

newlae<-newlm[,l]
attach(aub2)
lmu1<- lm(newlae~U0+factor(month)+factor(defn)+factor(amt)+factor(ncb)+factor(cont)+factor(aids), weights=sqrt(wgt2))
s21a <- summary(lmu1)$sigma^2
detach(aub2)

z1<- matrix(nrow=121,ncol=3)

for( i in 31:151){
j=(i-1)/1000
res1<-matrix(nrow=120,ncol=2)

for(k in 1:120){
nxx<-c(1,j,x1,fact1[k,])
nyx<-c(1,j,x2,fact1[k,])
y1<-nxx%*%coef(log1)
y2<-nyx%*%coef(lmu1)
res1[k,1]<-exp(y1)/(1+exp(y1))
res1[k,2]<-exp(y2+s21/2)
}

oa=i-30
z1[oa,1]<-apply(res1,2,mean)[1]
z1[oa,2]<-apply(res1,2,mean)[2]
z1[oa,3]<-z1[oa,1]*z1[oa,2]
}

res1a[,l]<-z1[,1]
res1b[,l]<-z1[,2]
res1c[,l]<-z1[,3]
}


## Multi-logit original model ##

aubm1 <- read.csv(file=paste(g3[m]),head=TRUE,sep=",")
aubm2<- aubm1
aubm2$month<-as.factor(aubm2$month)
aubm2$amt<-as.factor(aubm2$amt)
aubm3<-mlogit.data(aubm2,varying=NULL, choice="claim", shape="wide")

model1<-mlogit(claim~1|U0+month+amt+defn+cont+ncb+aids,data=aubm3)

attach(aubm2)
if(names(sort(-table(month)))[1]=="1"){x1<-c(0,0,0,0,0,0,0,0,0,0,0)}
if(names(sort(-table(month)))[1]=="2"){x1<-c(1,0,0,0,0,0,0,0,0,0,0)}
if(names(sort(-table(month)))[1]=="3"){x1<-c(0,1,0,0,0,0,0,0,0,0,0)}
if(names(sort(-table(month)))[1]=="4"){x1<-c(0,0,1,0,0,0,0,0,0,0,0)}
if(names(sort(-table(month)))[1]=="5"){x1<-c(0,0,0,1,0,0,0,0,0,0,0)}
if(names(sort(-table(month)))[1]=="6"){x1<-c(0,0,0,0,1,0,0,0,0,0,0)}
if(names(sort(-table(month)))[1]=="7"){x1<-c(0,0,0,0,0,1,0,0,0,0,0)}
if(names(sort(-table(month)))[1]=="8"){x1<-c(0,0,0,0,0,0,1,0,0,0,0)}
if(names(sort(-table(month)))[1]=="9"){x1<-c(0,0,0,0,0,0,0,1,0,0,0)}
if(names(sort(-table(month)))[1]=="10"){x1<-c(0,0,0,0,0,0,0,0,1,0,0)}
if(names(sort(-table(month)))[1]=="11"){x1<-c(0,0,0,0,0,0,0,0,0,1,0)}
if(names(sort(-table(month)))[1]=="12"){x1<-c(0,0,0,0,0,0,0,0,0,0,1)}
detach(aubm2)

resm1<-NULL
for(i in 31:151){
j=(i-1)/1000
resm2<-NULL
for(k in 1:120){
nxx<-c(1,j,x1,fact1[k,])
calc1<-sum(nxx*model1$coef[seq(1,length(model1$coef),by=3)])
calc2<-sum(nxx*model1$coef[seq(2,length(model1$coef),by=3)])
calc3<-sum(nxx*model1$coef[seq(3,length(model1$coef),by=3)])
calc<-cbind(0,calc1,calc2,calc3)
p.unscaled<-exp(calc)
resm2<-rbind(resm2,p.unscaled / rowSums(p.unscaled))
}
resm1<-rbind(resm1,apply(resm2,2,mean))

}

plotm1[,1]<-resm1[,1]
plotm2[,1]<-resm1[,2]
plotm3[,1]<-resm1[,3]
plotm4[,1]<-resm1[,4]

## Multi-logit Bootstrap ##

pfit<- fitted(model1,outcome=FALSE)
obsml<-dim(pfit)[1]

for (l in 1:1000){ 

newY<-vector(length=obsml)

for (n in 1:obsml){
ra1<-pfit[n,]
newd<-rmultinom(1,1,ra1)
newY[n]<-which(newd!=0)
}

attach (aubm2)
aubn<-data.frame(newY,U0,month,amt,defn,cont,ncb,aids)
detach(aubm2)

aubm3<-mlogit.data(aubn,varying=NULL, choice="newY", shape="wide")
model1<-mlogit(newY~1|U0+month+amt+defn+cont+ncb+aids,data=aubm3)

resma1<-NULL
for(i in 31:151){
j=(i-1)/1000
resma2<-NULL
for(k in 1:120){
nxx<-c(1,j,x1,fact1[k,])
calc1<-sum(nxx*model1$coef[seq(1,length(model1$coef),by=3)])
calc2<-sum(nxx*model1$coef[seq(2,length(model1$coef),by=3)])
calc3<-sum(nxx*model1$coef[seq(3,length(model1$coef),by=3)])
calc<-cbind(0,calc1,calc2,calc3)
p.unscaled<-exp(calc)
resma2<-rbind(resma2,p.unscaled / rowSums(p.unscaled))
}
resma1<-rbind(resma1,apply(resma2,2,mean))

}

resm1a[,l]<-resma1[,1]
resm1b[,l]<-resma1[,2]
resm1c[,l]<-resma1[,3]
resm1d[,l]<-resma1[,4]
}

## Combinined Results Original ##

abc1<- vector(length=121)
abc1[1]<-1000

for(j in 2:121){
abc1[j]<-1000+1000*(plot3[j,1]-plot3[1,1])/plot3[1,1]
}
plot4[,1]<-abc1
newplot1[,1]<-abc1*resm1[,1]
newplot2[,1]<-abc1*resm1[,2]
newplot3[,1]<-abc1*resm1[,3]
newplot4[,1]<-abc1*resm1[,4]

## Combined Results Bootstrap ##

for(l in 1:1000){

abc1<- vector(length=121)
abc1[1]<-1000

for(j in 2:121){
abc1[j]<-1000+1000*(res1c[j,l]-res1c[1,l])/res1c[1,l]
}

res1d[,l]<-abc1
nres1[,l]<-abc1*resm1a[,l]
nres2[,l]<-abc1*resm1b[,l]
nres3[,l]<-abc1*resm1c[,l]
nres4[,l]<-abc1*resm1d[,l]
}


## Exporting confidence intervals ##

plot1[,2]<-apply(res1a,1,quantile, probs=0.025, na.rm=TRUE)
plot1[,3]<-apply(res1a,1,quantile, probs=0.975, na.rm=TRUE)

plot2[,2]<-apply(res1b,1,quantile, probs=0.025, na.rm=TRUE)
plot2[,3]<-apply(res1b,1,quantile, probs=0.975, na.rm=TRUE)

plot3[,2]<-apply(res1c,1,quantile, probs=0.025, na.rm=TRUE)
plot3[,3]<-apply(res1c,1,quantile, probs=0.975, na.rm=TRUE)

plot4[,2]<-apply(res1d,1,quantile, probs=0.025, na.rm=TRUE)
plot4[,3]<-apply(res1d,1,quantile, probs=0.975, na.rm=TRUE)

con<-cbind(plot1,plot2,plot3,plot4)
write.table(con, paste(g2[m]), sep="\t")

plotm1[,2]<-apply(resm1a,1,quantile, probs=0.025, na.rm=TRUE)
plotm1[,3]<-apply(resm1a,1,quantile, probs=0.975, na.rm=TRUE)

plotm2[,2]<-apply(resm1b,1,quantile, probs=0.025, na.rm=TRUE)
plotm2[,3]<-apply(resm1b,1,quantile, probs=0.975, na.rm=TRUE)

plotm3[,2]<-apply(resm1c,1,quantile, probs=0.025, na.rm=TRUE)
plotm3[,3]<-apply(resm1c,1,quantile, probs=0.975, na.rm=TRUE)

plotm4[,2]<-apply(resm1d,1,quantile, probs=0.025, na.rm=TRUE)
plotm4[,3]<-apply(resm1d,1,quantile, probs=0.975, na.rm=TRUE)

conm<-cbind(plotm1,plotm2,plotm3,plotm4)
write.table(conm, paste(g4[m]), sep="\t")

newplot1[,2]<-apply(nres1,1,quantile, probs=0.025, na.rm=TRUE)
newplot1[,3]<-apply(nres1,1,quantile, probs=0.975, na.rm=TRUE)

newplot2[,2]<-apply(nres2,1,quantile, probs=0.025, na.rm=TRUE)
newplot2[,3]<-apply(nres2,1,quantile, probs=0.975, na.rm=TRUE)

newplot3[,2]<-apply(nres3,1,quantile, probs=0.025, na.rm=TRUE)
newplot3[,3]<-apply(nres3,1,quantile, probs=0.975, na.rm=TRUE)

newplot4[,2]<-apply(nres4,1,quantile, probs=0.025, na.rm=TRUE)
newplot4[,3]<-apply(nres4,1,quantile, probs=0.975, na.rm=TRUE)

conm1<-cbind(newplot1,newplot2,newplot3,newplot4)
conm1<-cbind(newplot1,newplot2,newplot3,newplot4)
write.table(conm1, paste(g5[m]), sep="\t")

}



